"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var unified_1 = __importDefault(require("unified"));
var remark_parse_1 = __importDefault(require("remark-parse"));
var remark_rehype_1 = __importDefault(require("remark-rehype"));
var rehype_stringify_1 = __importDefault(require("rehype-stringify"));
var remark_gfm_1 = __importDefault(require("remark-gfm"));
var rehype_raw_1 = __importDefault(require("rehype-raw"));
var unist_util_visit_1 = __importDefault(require("unist-util-visit"));
var unist_util_is_1 = __importDefault(require("unist-util-is"));
var rehype_sanitize_1 = __importDefault(require("rehype-sanitize"));
var deepmerge_1 = __importDefault(require("deepmerge"));
var githubSanitizeSchema = require("hast-util-sanitize/lib/github.json");
var sanitizeSchema = deepmerge_1.default(githubSanitizeSchema, {
    attributes: { "*": ["dataVueCode"] },
});
exports.default = (function (content) {
    return unified_1.default()
        .use(remark_parse_1.default)
        .use(remark_gfm_1.default)
        .use(remark_rehype_1.default, { allowDangerousHtml: true })
        .use(function () { return function (tree) {
        unist_util_visit_1.default(tree, function (node) {
            if (!unist_util_is_1.default(node, { tagName: "pre" }))
                return;
            var codeElement = node.children[0];
            var className = codeElement.properties.className;
            if (!className || className[0] !== "language-vue")
                return;
            var code = codeElement.children[0].value;
            node.tagName = "div";
            node.children = [];
            node.properties = {
                "data-vue-code": encodeURIComponent(code),
            };
        });
    }; })
        .use(rehype_raw_1.default)
        .use(rehype_sanitize_1.default, sanitizeSchema)
        .use(rehype_stringify_1.default)
        .process(content);
});
